variables:
  MAVEN_OPTS: "-Xmx8g -Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

image: maven:3.6-jdk-8

minimal_job:
  stage: test
  variables:
    GIT_STRATEGY: none
    GIT_CHECKOUT: "false"
  script:
    - echo ${CI_COMMIT_REF_NAME}
  rules:
    - if: '$CI_COMMIT_REF_NAME =~ /^tmp\/.*$/ || $CI_COMMIT_REF_NAME =~ /^backup\/.*$/'

verify_snapshot:
  stage: test
  script:
    - 'mvn -B -N versions:update-property -Dproperty=platform.legend-engine.version -DgenerateBackupPoms=false -DallowMajorUpdates=false -U'
    - 'mvn -B -N versions:update-property -Dproperty=platform.legend-sdlc.version -DgenerateBackupPoms=false -DallowMajorUpdates=false -U'
    - 'mvn -B versions:set -DnewVersion=$(echo -n $CI_COMMIT_REF_NAME | tr -c -s "[:alnum:].-" "_")-SNAPSHOT'
    - 'mvn -B -e clean deploy -s ci_settings.xml'
    - 'mkdir artifacts'
    - 'find ${CI_PROJECT_DIR}/mvn-deploy-dir \( -name "*.jar" -o -name "*.pom" \) -exec cp {} artifacts/ \;'
    - 'mkdir -p test-reports/junit'
    - 'find ${CI_PROJECT_DIR}/**/target/surefire-reports -name "*.xml" -exec cp {} test-reports/junit/ \;'
  artifacts:
    paths:
      - artifacts
      - test-reports
  rules:
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_REF_NAME == "master" || $CI_COMMIT_REF_NAME =~ /^tmp\/.*$/ || $CI_COMMIT_REF_NAME =~ /^backup\/.*$/'
      when: never
    - when: on_success

